﻿/********************************************************************************/
/* 	gamecore.d																	*/
/*------------------------------------------------------------------------------*/
/*	製作		瓦千鳥（あるふぁ～秘密基地）									*/
/*	製作開始	2012/09/04														*/
/*	MAIL		dij@estate.ocn.ne.jp											*/
/*	URL			http://www.geocities.jp/dij4121/alpha/							*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2012/09/08	初版															*/
/*	2012/09/16	ver1.01															*/
/*-その他-----------------------------------------------------------------------*/
/*	2012/09/04	tamakoroベースに作成											*/
/*	なし																		*/
/********************************************************************************/

private import state;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;
private import clickable;
//private import configparser;

import config;

//private import std.math;

/********************************************************************************/

//ConfigParser configparser = null;
const static string CONFIG_PATH = "config.ini";


/* GameMain *********************************************************************/
/*	ゲーム本体の状態															*/
/********************************************************************************/

class GameMain : GameState
{
public:
	//-----------------------------------------------------------------------------
	//システム制御用
	//-----------------------------------------------------------------------------
	enum SCENE{
		INIT = 0,
		START,
		MAIN,
		CLEAR,
		END,
		PAUSE,
		RELESE,
		
		//以下ゲーム内の演出
		PLAYER_WARP,
		ENEMY_GETWAIT,
		PLAYER_MISSWAIT,

		EXIT,
	};
	

	ConfigParser savedata;			// セーブデータ

	int timer;						// 汎用タイマー
	SCENE iSceneStatus;				//画面の状態
	int stage;						// ステージ
	int stage_start_count;			// ステージ開始処理
	int stage_clear_count;			// ステージ開始処理
	int game_score = 0;				//スコア
	int hi_score = 0;				//ハイスコア
	int game_time_count = 0;		//ゲーム終了までの残り時間
	int menu_input = 0;				//敵を倒したときのWAITカウンタ

	int drive = 0;					//進んだ距離
	int power = 0;					//パワーメータ
	int speed = 0;					//スピード
	
	int player_act = 0;				//状態
	int player_x = 100;				//表示位置
	int player_spd = 0;				//表示位置
	int atk = 0;					//攻撃力
	int atk2 = 0;					//攻撃　補正値％
	int atk_boost = 1;				//攻撃　補正値％
	int level = 1;					//ブロックの大きさ
//	int block[30];					//ブロックの大きさ
	int	block[30] = [  1,  1,  1,  1,  1,
					   2,  2,  2,  3,  3, 
					   1,  1,  1,  2,  2,
					   2,  3,  3,  3,  4,
					   3,  4,  5,  6,  7 ];
	int block_hp[30];				//ブロックのHP
	int max_hp[30];					//ブロックのMAX HP
	int block_move;					//ブロックの移動
	int zoome = 1;
	int damage_count = 0;			//ダメージカウンタ
	float g_size;					//溜めエフェクト
	int damage_effect[5];			//ダメージエフェクトカウンタ
	int damage_value[5];			//ダメージエフェクト数値
	
	int loop_i;						//汎用ループ
	int swap;						//汎用スワップ
	int r1;							//汎用スワップ乱数
	int r2;							//汎用スワップ乱数
	
	int test1 = 0;					//debug
	int test2 = 0;					//debug
	int test3 = 0;					//debug

	//位置構造体
	struct POS
	{
		float x;
		float y;
	}
	//エフェクト用構造体☆☆☆
	struct EFFECT_DATA
	{
		int exist;		//存在
		int type;		//透明度
		int timer;		//生存時間
		float pos_x;	//位置
		float pos_y;	//位置
		float size;		//位置
		int r;	//
		int g;	//
		int b;	//
		int alpha;	//透明度
		int dec_alpha;	//透明度
		float dir;	//方向
		float speed;//速度
		float zoom_x;	//
		float zoom_y;	//
		int move[10];	//汎用バッファ
	};
	const int EFFECT_MAX = 1024;
	EFFECT_DATA effect[EFFECT_MAX];

	Keypad keypad;					// キーボード/ゲームパッド取得用
	//-----------------------------------------------------------------------------
	//ゲーム別に使用される特別処理用変数
	//-----------------------------------------------------------------------------

	//-----------------------------------------------------------------------------
	//	コンストラクタ
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	this()
	{
		setMsg( GameState.MSG_NONE );
		// 各種初期化
		timer = 0;

		savedata          = new ConfigParser();
		keypad = new Keypad();
		keypad.SetUseCancel( false );

		iSceneStatus = SCENE.INIT;

	}

	
	//-----------------------------------------------------------------------------
	//	シーンの初期化
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void init( )
	{
Hell_write( "Gamecoer init\n" );
		//リソースの読み込み
		Hell_loadTexture("tama","resource/image/tama.bmp" , [0,255,0]);
		Hell_loadTexture("char","resource/image/char1.bmp" , [0,255,0]);
		Hell_loadTexture("map","resource/image/map.bmp" , [0,255,0]);
		Hell_loadTexture("effect","resource/image/effect_ball.bmp" , [0,255,0]);
		Hell_loadTexture("atk","resource/image/effect_atk.bmp" , [0,255,0]);
		Hell_loadTexture("bg01","resource/image/texture01_dl.bmp" , [0,255,0]);

		Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);

		Hell_loadWAV("get",         "resource/sound/l1.wav");
		Hell_loadWAV("door",        "resource/sound/puwa.wav");
		Hell_loadWAV("damage",        "resource/sound/damage.wav");
		Hell_loadWAV("select",        "resource/sound/select.wav");
		Hell_loadWAV("destroy",        "resource/sound/destroy2.wav");
		Hell_loadWAV("powerup",        "resource/sound/clear.wav");

		Hell_loadWAV("atk1",        "resource/sound/mm_bosu13.wav");
		Hell_loadWAV("atk2",        "resource/sound/mm_bom30.wav");


		//セーブデータ
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HI_SCORE",         999999);
			savedata.set("HOSHI",         1);
			savedata.write();
		}
		hi_score = savedata.getint("HI_SCORE");

		game_time_count = 0;		//ゲーム終了までの残り時間
		drive = 0;					//進んだ距離
		power = 0;					//
		
		
		for ( loop_i = 0 ; loop_i < 200 ; loop_i++ )//シャッフル
		{
			r1 = Hell_randInt(0, 10);
			r2 = Hell_randInt(0, 10);
			swap = block[r1];						
			block[r1] =  block[r2];				
			block[r2] =  swap;						
		}
		for ( loop_i = 0 ; loop_i < 200 ; loop_i++ )//シャッフル
		{
			r1 = Hell_randInt(0, 10) +10;
			r2 = Hell_randInt(0, 10) +10;
			swap = block[r1];						
			block[r1] =  block[r2];				
			block[r2] =  swap;						
		}
		
		for ( loop_i = 1 ; loop_i < 30 ; loop_i++ )
		{
			block_hp[loop_i] = 50 + block[loop_i] * block[loop_i] * 10;	//ブロックのHP設定
			max_hp[loop_i] = block_hp[loop_i];
		}
		block_move = 250 ;

Hell_write( "Gamecoer init\n" );

		iSceneStatus = SCENE.START;
	}
	


	//-----------------------------------------------------------------------------
	//	シーンの後処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void relese( )
	{
		iSceneStatus = SCENE.EXIT;
	}
	//-----------------------------------------------------------------------------
	//	開始演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_move( )
	{
		int i;

		if ( stage_start_count < ( 60 * 3 ) )
		{
			stage_start_count++;
		}
		else 
		{
			Hell_playBgm( "resource/sound/bgm.ogg", -1, 0 );
			iSceneStatus = SCENE.MAIN;
			stage_start_count = 0;
		}
	}
	//-----------------------------------------------------------------------------
	//	ステージ開始表示処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_draw( )
	{
		if ( stage_start_count > ( 60 * 2 ) )
		{
			Hell_drawFont(" GO! " , 240, 200 , 4 , 255,255,255);
		}
		else
		{
			Hell_drawFont("READY" , 240, 200 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_move( )
	{
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) )
//			if( keypad.isPushEnter(true) )
			{
				iSceneStatus = SCENE.RELESE;
			}
		}
		else 
		{
			stage_clear_count++;
		}
		
		
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の表示
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;

		Hell_setAlpha(HELL_ALPHA_NORMAL);
//		Hell_drawFont( "HI SCORE" , 400, 10 , 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( hi_score ) , 400, 30 , 4 , 255,255,255);

		Hell_drawFont( "RESULTS" , 200, 250 , 4 , 255,255,255);

		min = ( game_score / 60 ) / 60;
		sec = ( game_score / 60 ) % 60;
		msec = game_score % 60;
		str = std.string.format( "%02d:%02d:%02d", min, sec, msec );

		Hell_drawFont( "TIME" ,    210, 300 , 2 , 255,255,255);
		Hell_drawFont( str , 220, 320 , 4 , 255,255,255);
		if ( hi_score >= game_score )
		{
			Hell_drawFont( "NEW RECORD !",170, 390 , 4 , 255, 0, 0);
		}

		if ( stage_clear_count > ( 60 * 2 ) )
		{
			Hell_drawFont("MOUSE L BUTTON TO EXIT" , 140, 440 , 2 , 255,255,255);
		}
		else
		{
			Hell_drawFont(" CLEAR !" , 200, 420 , 4 , 255,255,255);
		}
		effect_move();
	}
	//-----------------------------------------------------------------------------
	//	ゲームオーバー演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneEnd( )
	{
//		iSceneStatus = SCENE.MAIN;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move()
	{
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			init( );
			break;
		case SCENE.START:
			//開始
			SeneStart_move( );
			break;
		case SCENE.MAIN:
			keypad.update( );	//リプレイキー入力の更新
			//メイン
			system_move( );

			break;
		case SCENE.CLEAR:
			//クリア
//			effect_move( );
//			mob_move( );
			SeneClear_move( );
			break;
		case SCENE.END:
			//ゲームオーバー
			break;
		case SCENE.PAUSE:
			//一時停止
			pause_move( );
			break;
		case SCENE.RELESE:
			//後処理
			relese( );
			break;

		case SCENE.EXIT:
		default:
			//シーンの終了
			setMsg(GameState.MSG_REQ_TITLE);
			break;
		}
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw()
	{
		// 作画開始
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			break;
		case SCENE.START:
			//開始
			system_draw( );

			SeneStart_draw( );
			break;
		case SCENE.MAIN:
			//メイン
			system_draw( );
			break;
		case SCENE.CLEAR:
			//クリア
			system_draw( );
			SeneClear_draw( );
			break;
		case SCENE.END:
			//ゲームーバー
			system_draw( );
			SeneEnd( );
			break;
		case SCENE.PAUSE:
			//一時停止
			system_draw( );
			pause_draw( );
			break;
		case SCENE.RELESE:
			//後処理
			break;
			
			
		case SCENE.EXIT:
		default:
			break;
		}
// for debug code start
Hell_drawFPS( 550, 10 );
//Hell_drawFont( std.string.toString( cast( int )scroll_status ), 10, 10 * 1, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )position.y ), 10, 10 * 2, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )place ), 10, 10 * 3, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )motion ), 10, 10 * 4, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )debug_disp[0] ), 10, 10 * 5, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )jump_fream_count ), 10, 10 * 6, 1 , 255,255,255 );
// for debug code end

	}
	
	// 画面サイズ取得
	int getScreenWidth(){return boot.g_width;}
	int getScreenHeight(){return boot.g_height;}
	
	string zfill(string str , int n)
	{
		for(int t=str.length;t<n;t++){
			str = "0" ~ str;
		}
		return str;
	}
	
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_move( )
	{
		//残り時間のカウント
		game_time_count++;
		timer++;
		
		if ( ( block_move > 0 ) && ( level < 25 ) )
		{
			block_move = block_move - 10;
		}
		if ( damage_count > 0 )
		{
			damage_count --;
		}
		if ( damage_effect[0] > 0 )
		{
			damage_effect[0] --;
		}
		
		
		
		
		if ( ( player_x <=100 ) && ( player_act != 5 ) )
		{
			player_act = 1;
		}
		if ( (Hell_isPressMouse() & HELL_BUTTON_LEFT) && (player_act == 1) )
		{
			power = power + 5 * atk_boost;
			if ( power > 300 )
			{
				atk_boost = atk_boost + 1 -( atk_boost == 3 ) *3;
				power = 5 * atk_boost;
			}
		}
		else if ( ( power > 0 ) && (player_act == 1) )
		{
			player_spd = 1;
			player_act = 5;
//			atk = ( power/3 * power/3 )/100;	//反比例型
//			atk = power / 3 ;					//正比例型
			atk = ( power/3 * power/3 )/200 + power / 6 ;					//反比例と正比例を合わせたもの
			atk2 = ( 300 - player_x ) / 2; 
		}
		else if ( player_act == 1 )
		{
			atk_boost = 1;
		}

		if (((Hell_isPressMouse() & HELL_BUTTON_RIGHT)) && ( player_x > 50 ) )	//助走距離を取る
		{
			player_x = player_x - 5;
			player_act = 6;
		}
		else if ( ( player_x > 100 ) && ( player_act != 5 ) && ( level < 25 ) )	//ダッシュ後の助走距離戻し
		{
			player_x = player_x - 5;
			player_act = 6;
		}

		if ( player_act == 5 )
		{
			player_x = player_x + player_spd ;
			player_spd = player_spd +1;
//			atk = atk * atk2 / 100;
			if ( player_x >= 300 )
			{
				player_act = 6;
				power = 0;
				atk = atk * atk2 /100 * atk_boost * atk_boost ;
				speed = atk / 2;
				atk_boost = 1;
				
				damage_effect[0] = 30;
				damage_value[0] = atk;

				test1 = speed;
				test2 = atk;
				
				block_hp[level] = block_hp[level] - atk;
				if ( block_hp[level] <= 0 )
				{
					block_move = 300;
					Hell_playWAV( "atk2", 0, -1 );//破壊SE
					create_effect( EFFECT_TYPE.EN_EFFECT_TYPE_ATK,
						300 + 64 + block[level] * 16  ,
						200 + 64 - 16 * block[level] + block[level] * 16 -32  ,
						180, 0, 128, 128, 255 , block[level]+2 );//爆発エフェクト
					level ++;
				}
				else
				{
					Hell_playWAV( "atk1", 0, -1 );//衝突SE
					create_effect( EFFECT_TYPE.EN_EFFECT_TYPE_CHARGE,
						300 + 64 ,				//+ level * 16,
						200 + 32 ,
						180, 0, 128, 128, 255 , g_size );
					if ( atk > 0 )
					{
						damage_count = 20;
					}
				}
			}
		}
		
		
		
//		drive = drive + speed ;					//進んだ距離
//		speed = cast( int )( speed * 0.8 );
		

//		if ( drive >= 640 )
		if ( level == 25 )
		{
			
			Hell_playBgm( "resource/sound/results.ogg", 1, 0 );

			//ハイスコアの保存
			game_score = game_time_count;
			if ( hi_score > game_score )
			{
				keypad.save( "replay/replay_01.bin" );	//リプレイの保存
				hi_score = game_score;
				savedata.set("HI_SCORE",   cast(int)hi_score);
				savedata.write();
			}

			iSceneStatus = SCENE.CLEAR;
		}
		
		if ( iSceneStatus == SCENE.MAIN )
		{
			if(keypad.isPushCancel(true))
			{
				//ポーズ
//				iSceneStatus = SCENE.PAUSE;
//				menu_input = 0;
			}
		}

		effect_move();
	}
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;
		int r = 255;
		int g = 255;
		int b = 255;
		int move_x;
		int move_y;
		int damage_y;
		
		
		Hell_drawTexture("bg01"		//BG表示
		, 0
		, 0
		, 0
		, 0
		, 640, 480
		, 1.0 , 1.0
		, 0
		,255, 255, 255, 100 );
		
		
//		Hell_drawTexture("tama"
//			, drive
//			, 200
//			, 0
//			, 0
//			, 64, 64
//			, 1.0 , 1.0
//			, 360 - ( drive % 360 )
//			,255, 255, 255, 255 );
		
		Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
		Hell_drawTexture("effect"			//パワーゲージ3
		, player_x - (g_size -1 ) *64 -32
		, 200 - (g_size -1 ) *64 -32
		, 0
		, 0
		, 128, 128
		, g_size , g_size
		, 0
		, 255, 255, 255, 200 );
		Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す

		if ( player_act == 0 )
		{
		Hell_drawTexture("char"
			, player_x
			, 200
			, 32 * player_act
			, 0
			, 32, 32
			, 2.0 , 2.0
			, 0
			,255, 255, 255, 255 );
		}
		else if ( player_act == 1 )
		{
			g_size = cast(float)power / 200 * atk_boost;
			
			Hell_drawTexture("char"
			, player_x + ( timer/20 % 2 )
			, 200 + ( ( timer+10)/20 % 2)
			, 32 * player_act
			, 32
			, 32, 32
			, 2.0 , 2.0
			, 0
			,255, 255, 255, 255 );

		}
		else
		{
		Hell_drawTexture("char"
			, player_x
			, 200 
			, 32 * player_act
			, 32
			, 32, 32
			, 2.0 , 2.0
			, 0
			,255, 255, 255, 255 );
		}
		
		if ( player_act == 6 )
		{
			g_size = 0;
		}

		if ( damage_count > 0 )
		{
			move_x = Hell_randInt(0, 8)-4;
			move_y = Hell_randInt(0, 8)-4;
		}
		else
		{
			move_x = 0;
			move_y = 0;

		}

		
		Hell_drawTexture("map"
			, 300 + 64 + block_move + move_x
			, 200 + 64 - 16 * block[level] -32 + move_y
			, 32 *cast(int)(level/5+1)
			, 32
			, 32, 32
			, block[level] , block[level]
			, 0
			,255, 255, 255, 255 );
		
		Hell_drawRect( 400 - 2 + block_move, 216 - 2, 100 + 4, 10 + 4, 0, 0, 255, 255, 255, 255);
		Hell_drawRect( 400 + block_move, 216, 100, 10, 0, 0, 0, 0, 0, 255);
		if ( block_hp[level] > 0 )
		{
			Hell_drawRect( 400 + block_move, 216, cast(int)((cast( float )block_hp[level]/cast( float )max_hp[level])*100)+1, 10, 0, 0, 255, 0, 0, 255);
		} 
		str = std.string.format( "%03d", block_hp[level] );
		Hell_drawFont( str , 435 + block_move , 216 , 1.5 , 255,255,255);
		
		
		
		if ( atk_boost > 1 )
		{
			str = std.string.format( "boost %01d", atk_boost-1 );
			Hell_drawFont( str , 80+ 10 , 320 , 1.5 , 255,  0,  0);
		}
		else
		{
		Hell_drawFont( "POWER" , 100, 320 , 1.5 , 255,255,255);
		}
		
		Hell_drawRect( 80 - 2, 300 - 2, 100 + 4, 10 + 4, 0, 0, 255, 255, 255, 255);
		Hell_drawRect( 80, 300, 100, 10, 0, 0, 0, 0, 0, 255);
		if ( power > 0 )
		{
			Hell_drawRect( 80, 300, cast( int )power/3, 10, 0, 0, (atk_boost == 3 ) *255, 255, (atk_boost >= 2 ) *255 , 255);
		} 
		str = std.string.format( "%03d", power/3 * atk_boost );
		Hell_drawFont( str , 80+35 , 300 , 1.5 , 255,255,255);

		
		effect_draw( );
		
		if ( ( damage_value[0] > 0 ) && ( damage_effect[0] > 0 ) && ( level < 25 ))		//ダメージ表示
		{
			damage_y = (damage_effect[0] >20  ) * (damage_effect[0] -20) * (damage_effect[0] -20) //*  3 
					 + (damage_effect[0] <=20 ) * (damage_effect[0] -20) * (damage_effect[0] -20) ;//* -2;
			str = std.string.format( "%01d", damage_value[0] );
			Hell_drawFont( str , 400 + move_x , 180 + damage_y + move_y , (cast(float)damage_value[0]/150)+2.0 , 255,255,255);
		}
		
		
		
		min = ( game_time_count / 60 ) / 60;
		sec = ( game_time_count / 60 ) % 60;
		msec = game_time_count % 60;
		
		if ( iSceneStatus != SCENE.CLEAR )
		{
			str = std.string.format( "TIME %02d:%02d:%02d", min, sec, msec );
			Hell_setAlpha(HELL_ALPHA_NORMAL);
			Hell_drawFont( str , 100, 100 , 3 , r,g,b);
			
			Hell_drawTexture("map"
				, 450 
				, 100 -4 
				, 32 * 1
				, 32
				, 32, 32
				, 1.0 , 1.0
				, 0
				,255, 255, 255, 255 );
			str = std.string.format( "x %02d", 25 - level );
			Hell_drawFont( str , 490 , 104 , 2 , 255,255,255);
		}


//		Hell_drawFont( "SCORE" , 10, 10 , 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( game_score ) , 10, 30 , 4 , 255,255,255);

		min = ( hi_score / 60 ) / 60;
		sec = ( hi_score / 60 ) % 60;
		msec = hi_score % 60;

		Hell_drawFont( "HI SCORE" , 300, 10 , 2 , 255,255,255);
		str = std.string.format( "%02d:%02d:%02d", min, sec, msec );
		Hell_drawFont( str , 300, 30 , 4 , 255,255,255);

		Hell_drawFont( "Ver. 1.01 ",520, 470 , 1.0 , 255,255,200);

/*
		//debug disp
		Hell_drawFont( "T1" , 500, 400 , 2 , 255,255,255);
		str = std.string.format( "%05d", test1 );
		Hell_drawFont( str , 550, 400 , 2 , 255,255,255);
		Hell_drawFont( "T2" , 500, 420 , 2 , 255,255,255);
		str = std.string.format( "%05d", test2 );
		Hell_drawFont( str , 550, 420 , 2 , 255,255,255);
		Hell_drawFont( "T3" , 500, 440 , 2 , 255,255,255);
		str = std.string.format( "%05d", test3 );
		Hell_drawFont( str , 550, 440 , 2 , 255,255,255);
*/
	}
	
	//-----------------------------------------------------------------------------
	//	エフェクトの作成
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	爆発の表示 	120623-   
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	enum EFFECT_TYPE
	{
		EN_EFFECT_TYPE_ATTACK,
		EN_EFFECT_TYPE_YELL1,
		EN_EFFECT_TYPE_YELL2,
		EN_EFFECT_TYPE_YELL3,
		EN_EFFECT_TYPE_YELL3_2,
		EN_EFFECT_TYPE_ATK,
		EN_EFFECT_TYPE_GRAZE,
		EN_EFFECT_TYPE_CHARGE,
	}
	
	void create_effect( int type, float x, float y, float dir, float speed, int r, int g, int b ,float size )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist == 0 )
			{
				effect[i].exist = 1;	//存在
				effect[i].type = type;	//
				effect[i].timer = 0;	//生存時間
				effect[i].pos_x = x;	//位置
				effect[i].pos_y = y;	//位置
				effect[i].size = size;	//位置
				effect[i].alpha = 255;	//透明度
				effect[i].dir = dir;	//
				effect[i].speed = speed;	//

				//タイプによってパラメータを分けるといいかも
				effect[i].r = r;	//色
				effect[i].g = g;	//色
				effect[i].b = b;	//色
				effect[i].zoom_x = 0.3;	//拡大率
				effect[i].zoom_y = 0.3;	//拡大率
				effect[i].dec_alpha = 8;	//透明度
				effect[i].move[] = 0;	//汎用バッファ
				
				switch( effect[i].type )
				{
				case EFFECT_TYPE.EN_EFFECT_TYPE_ATTACK:
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL1:
					//YELLエフェクト1
					effect[i].zoom_x = 0.3;	//拡大率
					effect[i].zoom_y = 0.3;	//拡大率
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL2:
					//YELLエフェクト2
					effect[i].zoom_x = 0.5;	//拡大率
					effect[i].zoom_y = 0.5;	//拡大率
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL3:
					//YELLエフェクト3
					effect[i].zoom_x = 0.5;	//拡大率
					effect[i].zoom_y = 0.5;	//拡大率
					effect[i].alpha = 255/2;	//透明度
					effect[i].dec_alpha = 8/2;	//透明度
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL3_2:
					//YELLエフェクト3
					effect[i].zoom_x = 0.3;	//拡大率
					effect[i].zoom_y = 0.3;	//拡大率
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_ATK:		//爆発
					//YELLエフェクト5
					effect[i].zoom_x = 1;	//拡大率
					effect[i].zoom_y = 1;	//拡大率
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_GRAZE:		//カスリ
					//YELLエフェクト6
					effect[i].zoom_x = 1;	//拡大率
					effect[i].zoom_y = 1;	//拡大率
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_CHARGE:		//溜め
					//YELLエフェクト7
					effect[i].zoom_x = 1;	//拡大率
					effect[i].zoom_y = 1;	//拡大率
					effect[i].dec_alpha = 4;	//透明度
					break;
				default:
					break;
				}
				
				break;
			}
		}
	}
	//エフェクトの表示
	void effect_draw( )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if (( effect[i].exist != 0 ) && ( effect[i].type == EFFECT_TYPE.EN_EFFECT_TYPE_GRAZE ) )
			{
				//種類を増やす場合はtypeで処理をわける
				Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
				Hell_drawTextureEx("effect"
					, effect[i].pos_x
					, effect[i].pos_y
					, 0
					, 0
					, 128, 128
					, effect[i].zoom_x * zoome , effect[i].zoom_y * zoome
					, 0
					,effect[i].r, effect[i].g, effect[i].b, effect[i].alpha );
			}
			if (( effect[i].exist != 0 ) && ( effect[i].type == EFFECT_TYPE.EN_EFFECT_TYPE_CHARGE ) )
			{
				//種類を増やす場合はtypeで処理をわける
				Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
				Hell_drawTextureEx("effect"
					, effect[i].pos_x
					, effect[i].pos_y
					, 0
					, 0
					, 128, 128
					, effect[i].zoom_x * zoome , effect[i].zoom_y * zoome
					, 0
					,effect[i].r, effect[i].g, effect[i].b, effect[i].alpha );
			}
			if (( effect[i].exist != 0 ) && ( effect[i].type == EFFECT_TYPE.EN_EFFECT_TYPE_ATK ) )
			{
				//種類を増やす場合はtypeで処理をわける
				Hell_setAlpha( HELL_ALPHA_ADD );	//加算半透明
				Hell_drawTexture("atk"
					, effect[i].pos_x -20 * zoome * effect[i].size
					, effect[i].pos_y -20 * zoome * effect[i].size
					, cast(int)((255-effect[i].alpha)/16)*40
					, 0
					, 40, 40
					, effect[i].zoom_x * zoome * effect[i].size , effect[i].zoom_y * zoome * effect[i].size
					, 0
					, 255, 255, 255, 255 );
			}
		}
		Hell_setAlpha( HELL_ALPHA_NORMAL );			//通常半透明に戻す
	}
	//エフェクトの移動
	void effect_move( )
	{
		int i = 0;
		for ( i = 0; i < EFFECT_MAX; i++ )
		{
			if ( effect[i].exist != 0 )
			{
				effect[i].timer++;	//生存時間

				float vx = Hell_sinEx( effect[i].dir ) * effect[i].speed * zoome;
				float vy = Hell_cosEx( effect[i].dir ) * effect[i].speed * zoome;
				effect[i].pos_x += vx;	//位置
				effect[i].pos_y += vy;	//位置

				//種類を増やす場合はtypeで処理をわける

				switch( effect[i].type )
				{
				case EFFECT_TYPE.EN_EFFECT_TYPE_ATTACK:
					effect[i].zoom_x -= 0.01;	//
					effect[i].zoom_y -= 0.01;	//
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL1:
					//YELLエフェクト1
					effect[i].zoom_x -= 0.005;	//
					effect[i].zoom_y -= 0.005;	//
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL2:
					//YELLエフェクト2
					effect[i].zoom_x = 0.5;	//拡大率
					effect[i].zoom_y = 0.5;	//拡大率
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL3:
					//YELLエフェクト3
					effect[i].zoom_x -= 0.005;	//
					effect[i].zoom_y -= 0.005;	//
					effect[i].dir -= 2;
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_YELL3_2:
					//YELLエフェクト3_2
					effect[i].zoom_x -= 0.01;	//
					effect[i].zoom_y -= 0.01;	//
					effect[i].dir -= 0;
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_ATK:
					//YELLエフェクトATK
//					effect[i].zoom_x -= 0.01;	//
//					effect[i].zoom_y -= 0.01;	//
					effect[i].dir -= 0;
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_GRAZE:
					//YELLエフェクトATK
//					effect[i].zoom_x -= 0.01;	//
//					effect[i].zoom_y -= 0.01;	//
					effect[i].dir -= 0;
					break;
				case EFFECT_TYPE.EN_EFFECT_TYPE_CHARGE:
					//YELLエフェクトATK
//					effect[i].zoom_x -= 0.01;	//
//					effect[i].zoom_y -= 0.01;	//
					effect[i].dir -= 0;
					break;
				default:
					break;
				}

				if ( effect[i].zoom_x < 0.0 )
				{
					effect[i].zoom_x = 0.0;
				}
				if ( effect[i].zoom_y < 0.0 )
				{
					effect[i].zoom_y = 0.0;
				}

				effect[i].alpha -= effect[i].dec_alpha;	//透明度
				
				if ( effect[i].alpha < 0 )
				{
					effect[i].exist = 0;	//消える 
				}
			}
		}
	}
	//方向と速度から位置を求める
	POS GetDirSpd_To_Position( float dir, float spd, int x, int y)
	{
		POS rc;

		float vx = Hell_sinEx( dir ) * spd;
		float vy = Hell_cosEx( dir ) * spd;

		rc.x = x + vx;
		rc.y = y + vy;
		
		return( rc );
	}
	//-----------------------------------------------------------------------------
	//	ポーズの処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_move( )
	{
		if(keypad.isPushUp(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input++;
			if ( menu_input > 1 )
			{
				menu_input = 0;
			}
		}
		else if(keypad.isPushDown(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input--;
			if ( menu_input < 0 )
			{
				menu_input = 1;
			}
		}
		if(keypad.isPushEnter(true))
		{
			switch ( menu_input )
			{
			case 0:
				//ポーズ解除
				iSceneStatus = SCENE.MAIN;
				break;
			case 1:
				//リトライ
				iSceneStatus = SCENE.RELESE;
				break;
			default:
				break;
			}
		}
		if(keypad.isPushCancel(true))
		{
			//ポーズ解除
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTexture("menu"
			, 96 + 160
			, 64 + 120 + ( menu_input * 32 )
			, 320
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawTexture("menu"
			, 160
			, 120
			, 0
			, 0
			, 320, 240
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
	}
	
	
}


